@// Template for Java
@// (C) Rolf Simon Adelsberger (rsa@student.ethz.ch)

@openfile generated/java/J_StateMachine.java
// generated by su4sml GSMCG - Generic State Machine Code Generator
@foreach classifier_list
@if hasAG
@nl
@nl import java.util.Hashtable;
@nl import java.util.Vector;
@nl
@nl abstract class EvalClass
@nl {
@nl @tab	public abstract boolean eval();
@nl }
@nl
@nl class Transition
@nl {
@nl @tab public State target;
@nl @tab public EvalClass[] guards;
@nl @tab public EvalClass[] restrictions;
@nl @tab public EvalClass[] effects;
@nl
@nl @tab public Transition(State t, EvalClass[] guardArray, EvalClass[] restrictionArra)
@nl @tab {
@nl @tab@tab target = t;
@nl @tab@tab guards = guardArray;
@nl @tab@tab restrictions = restrictionArray;
@nl @tab }
@nl
@nl
@nl class State
@nl {
@nl @tab public String name;
@nl @tab public Hashtable transitions;
@nl @tab State(String n) {
@nl @tab@tab name = n;
@nl @tab@tab transitions = new Hashtable();
@nl }
@nl
@nl
@nl public class StateMachine
@nl {
@nl @tab private State CUR_STATE;
@nl @tab State START;
@nl @tab State END;
@nl @tab
@nl
	@foreach event_list
		@nl @tab@tab EvalClass $trigger_name$ = new EvalClass();
	@end
@nl
@nl @tab private String[] EVENTS =
@nl @tab {
@nl @tab@tab "ALWAYS",
	@foreach event_list
		@nl @tab@tab "$event_name$",
	@end
@nl @tab@tab "NUM_EV"
@nl @tab };
@nl
@nl @tab private void init_states()
@nl @tab {
	@//@nl @tab@tab START = new State("Initial");
	@foreach state_list
		@nl @tab@tab $state_name$ = new State("$state_ident$");
	@end
	@nl @tab@tab END = new State("Final");
@nl @tab }
@nl
@nl @tab public StateMachine()
@nl @tab {
@nl @tab@tab init_states();
@nl @tab@tab CUR_STATE = START;
@nl @tab }
@nl
@nl @tab public StateMachine()
@nl @tab {
@nl @tab init_states();
@nl
	@foreach state_list
		@foreach events_of_state
			@nl
			@nl @tab@tab $state_name$.transitions.put("$cur_event_id$",new Transition[]{
				@foreach transition_list
					@nl @tab@tab@tab
					new Transition($transition_target$,
					@nl @tab@tab@tab@tab new EvalClass[]{
						@foreach guard_list
							$guard_ident$
							if isLastGuard
								} @//closing the guard array
							else
								,
							@end
						@end @//of guard_list
						,
					@nl @tab@tab@tab@tab new EvalClass[]{
						@foreach restriction_list
							$restriction_ident$,
						@end
						})
						@if isLastTrans
							}); @//end of transition array for this event
						@else 
							, @//separate transitions
						@end
				@end @//transition_list
		@end @//events_of_state
		@nl
		@nl
		@if isStart
			@nl @tab@tab START = $state_name$;
		@end
	@end @//state_list
@nl @tab CUR_STATE = START;
@nl @tab END = $final_state_name$;
@nl }
@nl
@nl public boolean alwaysG(){return true;}
@nl public boolean elseG(){return true;}
@nl public boolean noneR(){return true;}
@nl
@nl boolean checkState(String EVENT_ID)
@nl {
@nl @tab return (CUR_STATE.transistion.containsKey(EVENT_ID));
@nl }
@nl
	@foreach event_list
		@nl @tab class $trigger_name$ implements EvalClass
		@nl @tab {
		@nl @tab public void eval()
		@nl @tab {
		@nl @tab@tab String E_ID = $event_name$;
		@nl @tab@tab if(checkState(E_ID))
		@nl @tab@tab {
		@nl @tab@tab@tab Transition[] trans = (Transition[]) CUR_STATE.transitions.get(E_ID);
		@nl @tab@tab@tab for(int i = 0; i < trans.length; i++)
		@nl @tab@tab@tab {
		@nl @tab@tab@tab@tab for(int j = 0; j < trans[i].guards.length; j++)
		@nl @tab@tab@tab@tab {
		@nl @tab@tab@tab@tab@tab if(trans[i].guards[j].eval())
		@nl @tab@tab@tab@tab@tab {
		@nl @tab@tab@tab@tab@tab CUR_STATE = trans[i].target;
		@nl @tab@tab@tab@tab@tab return;
		@nl @tab@tab@tab@tab@tab } else {
		@nl @tab@tab@tab@tab@tab break;
		@nl @tab@tab@tab@tab@tab }
		@nl @tab@tab@tab@tab }
		@nl @tab@tab@tab }
		@nl @tab@tab } else {
		@nl @tab@tab@tab System.out.println("Current state does not accept this event!\n");
		@nl @tab@tab }
		@nl @tab }
		@nl @tab } //end of class $trigger_name$
	@end
@nl }
@end @//foreach classifier_list
@end @if...
